/*
  Name: DL programowanie zadanie 12 z rozdziau 16 ksiki Thinking in C++
  Author: Piotr Leo
  Date: 27-06-06 19:28
  Description: zadaniem byo wykorzystanie jakos wewntrznej implementacji klasy Stack klasy vector 
*/
//: C16:TStack2.h
// From Thinking in C++, 2nd Edition
// Available at http://www.BruceEckel.com
// (c) Bruce Eckel 2000
// Copyright notice in Copyright.txt
// Templatized Stack with nested iterator
#ifndef TSTACK2_H
#define TSTACK2_H

#include <vector>
#include "require.h"

using namespace std;

template<class T> class Stack 
{
         vector<T*> v;        //jako wewnetrzna implementacje wykorzystujemy klase vector
  public:
         Stack() : v(0) {}    //konstruktor, tworzy wektor o zerowej dlugosci
         ~Stack();            //destruktor
         void push(T* dat)    //metoda dodajaca element na koniec wektora
         {
          v.push_back(dat);   //dodajemy do wektora element
          //head = new Link(dat, head);
         }
         T* peek() const 
         { 
            return 0;//head ? head->data : 0;
         }
         T* pop();          //metoda sciagajaca element
         // Nested iterator class:
  /*Podczas tworzenia zagniedonej, zaprzyjanionej (friend) klasy naley najpierw zadeklarowa jej
  nazw, nastpnie zadeklarowa j jako klas zaprzyjanion, a dopiero potem zdefiniowa sam klas*/
         class iterator; //deklarujemy
         friend class iterator; //zaprzyjazniamy
         class iterator  //zagniezdzona, zaprzyjazniona klasa
         { //definicja klasy iterator
                      Stack& itS; //przezywamy Stack jako itS
                      int index;  //potrzebny w iteratorze jako licznik, wskazuje pozycje iteratora
               public:
                      iterator( Stack<T>& tl) : itS(tl), index(0){}  //konstruktor domyslny, ustawia indeks na pierwszy element wektora
                      // Copy-constructor:
					  
                     iterator(const iterator& tl) : itS(tl.itS), index(tl.index){} //konstruktor kopiujacy, ustawia indeks na wskazany element wektora
                      
                      //The end sentinel iterator:
                      iterator( Stack<T>& tl, bool) : itS(tl), index(tl.v.end()+1){} //konstruktor wskazujacy na koniec wektora
                      
                      // operator++ returns boolean indicating end:           
                      bool operator++()     //operator sluzacy do przechodzenia po kolejnych elementach obiektu klasy vector
                      {
                       //if(index<itS.v.size()) //jesli index jest mniejszy od rozmiaru wektora, inkrementujemy go    if(index<itS.v.size()-1)
                       //index++;
                       //else index = 0;          //w przeciwnym razie zerujemy indeks - wyszedl poza zakres
                       //return bool(index);
                       return (bool) itS.v[index++];      //zwracamy logiczna wartosc konca
                      }
                      
                      bool operator++(int) { return (bool) itS.v[++index]; } //operator preinkrementacji
                      
					  T* current() const /*Funkcja skadowa current( ) zwraca wskaznik na element kontenera, ktry jest aktualnie wybrany przez iterator*/
                      {
                       return itS.v[index];         //zwracamy wskaznik na konkretny element wektora
                      }
                      
					  // Pointer dereference operator: //operator wyluskania zwracajacy wskaznik na podany typ T
                      T* operator->() const 
                      { 
                        require(index != 0, "Stack::iterator::operator->returns 0"); 
                        return current(); 
                      }
                      T* operator*() const { return current(); }  //kolejny operator sluzacy do uzyskania dostepu do konkretnego elementu w naszym wektorze
                      // bool conversion for conditional test:
                      operator bool() const { return bool(index); } //zwracamy wartosc logiczna
                      // Comparison to test for end:
                      bool operator==(const iterator&) const  //operator porownania
                      {
                       return index == 0;
                      }
                      bool operator!=(const iterator&) const 
                      {
                       return index != 0;
                       }
         };
         iterator begin()  
         { 
             return iterator(*this); 
         }
         iterator end() 
         {
             //return 0;
             return iterator(*this); 
         }
         /*start i end s dwoma iteratorami, wyznaczajcymi zakres. Iterator
         end, nazywany jest czsto wartownikiem albo znacznikiem koca (ang. end sentinel),
         nie jest wyuskiwany; informuje nas jedynie, e znajdujemy si ju na kocu sekwencji.
         Tak wic reprezentuje on element nastpny po ostatnim".*/
};

template<class T> Stack<T>::~Stack() {
 v.resize(0);
}

template<class T> T* Stack<T>::pop() 
{
  if(!v.empty()) //jezeli obiekt nie jest pusty
  {
        v.pop_back();
        //v.resize(v.end()-2);
        //v.erase(v.end()--); //czyscimy
  }
}
#endif // TSTACK2_H ///:~
